<?php

function integrate_recent_topics()
{
	global $context;

	$context['latest_post'] = getRecentTopics();
}

function getRecentTopics($limit = 10)
{
	global $user_info, $modSettings;

	$db = database();
	$request = $db->query('', '
		SELECT m.id_msg, t.id_topic, 
			IFNULL(m.poster_time, 0) AS poster_time, IFNULL(mem.member_name, m.poster_name) AS poster_name,
			m.subject, m.id_topic, IFNULL(mem.real_name, m.poster_name) AS real_name,
			' . ($user_info['is_guest'] ? ' 1 AS is_read, 0 AS new_from,' : '
			(IFNULL(lb.id_msg, 0) >= b.id_msg_updated) AS is_read, IFNULL(lb.id_msg, -1) + 1 AS new_from,') . '
		FROM {db_prefix}topics AS t
			LEFT JOIN {db_prefix}messages AS m ON (m.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . ($user_info['is_guest'] ? '' : '
			LEFT JOIN {db_prefix}log_boards AS lb ON (lb.id_board = b.id_board AND lb.id_member = {int:current_member})' . '
		WHERE {query_see_board}
		ORDER BY m.id_msg
		LIMIT {int:limit}',
		array(
			'current_member' => $user_info['id'],
			'limit' => $limit
		)
	);
	$latest = array();
	while ($row = $db->fetch_assoc($request))
	{
		censorText($row['subject']);
		if (function_exists('shorten_text'))
			$row['short_subject'] = horten_text($row['subject'], $modSettings['subject_length']);
		else
			$row['short_subject'] = Util::shorten_text($row['subject'], $modSettings['subject_length']);
		$this_last_post = array(
			'id' => $row['id_msg'],
			'time' => $row['poster_time'] > 0 ? standardTime($row['poster_time']) : $txt['not_applicable'],
			'html_time' => $row['poster_time'] > 0 ? htmlTime($row['poster_time']) : $txt['not_applicable'],
			'timestamp' => forum_time(true, $row['poster_time']),
			'subject' => $row['short_subject'],
			'member' => array(
				'id' => $row['id_member'],
				'username' => $row['poster_name'] != '' ? $row['poster_name'] : $txt['not_applicable'],
				'name' => $row['real_name'],
				'href' => $row['poster_name'] != '' && !empty($row['id_member']) ? $scripturl . '?action=profile;u=' . $row['id_member'] : '',
				'link' => $row['poster_name'] != '' ? (!empty($row['id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['real_name'] . '</a>' : $row['real_name']) : $txt['not_applicable'],
			),
			'start' => 'msg' . $row['new_from'],
			'topic' => $row['id_topic'],
		);
		$this_last_post['href'] = $scripturl . '?topic=' . $row['id_topic'] . '.msg' . ($user_info['is_guest'] ? $row['id_msg'] : $row['new_from']) . (empty($row['is_read']) ? ';boardseen' : '') . '#new';
		$this_last_post['link'] = '<a href="' . $this_last_post['href'] . '" title="' . $row['subject'] . '">' . $row['short_subject'] . '</a>';

		$latest[] = $this_last_post;
	}

	return $latest;
}
